#property copyright "Copyright  2008, Xnko"
#property link      "xnko@mail.ru"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_width1 2
#property indicator_color2 Blue
#property indicator_width2 1
#property indicator_color3 Green
#property indicator_width3 1

#include "../include/AT&CF.mqh"

extern int PERIOD1 = PERIOD_H4;
extern int PERIOD2 = PERIOD_H1;
extern int PERIOD3 = PERIOD_M15;

double IH4[];
double IH1[];
double IM15[];

string PeriodName(int period)
{
   switch(period)
   {
      case PERIOD_M1:  return ("1 Minute");
      case PERIOD_M5:  return ("5 Minute");
      case PERIOD_M15: return ("15 Minute");
      case PERIOD_M30: return ("30 Minute");
      case PERIOD_H1:  return ("1 Hour");
      case PERIOD_H4:  return ("4 Hour");
      case PERIOD_D1:  return ("1 Day");
      case PERIOD_W1:  return ("1 Week");
      case PERIOD_MN1: return ("1 Mounth");
      default:
         return ("Unknown");
   }
}

int init()
{
   IndicatorBuffers(3);

   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexStyle(2, DRAW_LINE);

   SetIndexBuffer(0, IM15);
   SetIndexBuffer(1, IH1);
   SetIndexBuffer(2, IH4);

   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   SetIndexEmptyValue(2, 0.0);
   
   string p1 = PeriodName(PERIOD1);
   string p2 = PeriodName(PERIOD2);
   string p3 = PeriodName(PERIOD3);
   
   IndicatorShortName("Trend (" + p1 + ", " + p2 + ", " + p3 + ")");

   SetIndexLabel(0, p3);
   SetIndexLabel(1, p2);
   SetIndexLabel(2, p1);

   return(0);
}

int deinit()
{
   return(0);
}

#define CountBars 100

static double H4[300];
static double H1[300];
static double M15[300];

static double fH4[200];
static double fH1[200];
static double fM15[200];

static double foH4[CountBars];
static double foH1[CountBars];
static double foM15[CountBars];

int start()
{
   if(Bars < CountBars)
      return (0);

   int i;

   for(i = 0; i < CountBars * 3; i++)
   {
      H4[i]  = iClose(NULL, PERIOD1, i);
      H1[i]  = iClose(NULL, PERIOD2, i);
      M15[i] = iClose(NULL, PERIOD3, i);
   }

   Fatl(H4, fH4,   CountBars * 2);
   Fatl(H1, fH1,   CountBars * 2);
   Fatl(M15, fM15, CountBars * 2);

   for(i = 0; i < CountBars; i++)
   {
      foH4[i]  = iFatl(fH4, i)  - iFatl(fH4,  i + 1);   
      foH1[i]  = iFatl(fH1, i)  - iFatl(fH1,  i + 1);   
      foM15[i] = iFatl(fM15, i) - iFatl(fM15, i + 1);   
   }
   
   for(i = 0; i <= CountBars; i++)
      IH4[i] = foH4[i];

   for(i = 0; i <= CountBars; i++)
      IH1[i] = foH1[i];

   for(i = 0; i <= CountBars; i++)
      IM15[i] = foM15[i] * 3;
   
   return(0);
}